###############################################################################
# Display.pl                                                                  #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.1                                                    #
# Released:       November 8, 2005                                            #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2005 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$displayplver = 'YaBB 2.1 $Revision: 1.5 $';
if ($action eq 'detailedversion') { return 1; }

LoadLanguage("QuickReply");
LoadLanguage("Display");
LoadLanguage("FA");
LoadLanguage("SubBoard");
# RECENT USER LIST START
LoadLanguage("RecentUserList");
# RECENT USER LIST END
require "$templatesdir/$usedisplay/Display.template";
if ($iamgmod) { require "$vardir/gmodsettings.txt"; }

sub Display {

	# Check if board was 'shown to all' - and whether they can view the topic
	if (&AccessCheck($currentboard, '', $boardperms) ne "granted") { &fatal_error("$maintxt{'1'}"); }

	if ($INFO{'start'} eq "new") {

		# This decides which messages were already read in the thread to
		# determing where the redirect should go. It is done by
		# comparing times in the username.log and the boardnumber.txt files.
		if (!$iamguest && $max_log_days_old) {
			$mnum = $INFO{'num'};
			&getlog($mnum);
			$dlp = $yyuserlog{$mnum} || 0;
			$dlpb = $yyuserlog{"$currentboard--mark"} || 0;
			$dlp = $dlp > $dlpb ? $dlp : $dlpb;
			$dlp = $dlp > $date - ($max_log_days_old * 86400) ? $dlp : $date - ($max_log_days_old * 86400);    #renew prevent
			$i = 0;
			### Reverse Post Order mod ###
			fopen(MSGTXT,"$datadir/$mnum.txt") || &fatal_error("104 $display_txt{'106'}: $display_txt{'23'} $mnum.txt", 1);
			@msgtxt = <MSGTXT>;
			fclose(MSGTXT);
			foreach $mess ( @msgtxt ) {
				@tmp = split(/\|/, $mess);
				if ( $tmp[3] > $dlp) {last;}
				$i++;
			} 
			if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') {$i = ($#msgtxt - $i);}
			### Reverse Post Order mod end ###
			if ($currentboard eq $annboard) {
				$yySetLocation = qq~$scripturl?virboard=$INFO{'virboard'};num=$mnum/$i#$i~;
			} else {
				$yySetLocation = qq~$scripturl?num=$mnum/$i#$i~;
			}
			&redirectexit;
		}
	}
	### Reverse Post Order mod ###
	if(${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement' && !$INFO{'revpost'}){
		fopen(MSGTXT,"$datadir/$INFO{'num'}.txt") || &fatal_error("104 $display_txt{'106'}: $display_txt{'23'} $viewnum.txt", 1);
		@msgtxt = <MSGTXT>;
		fclose(MSGTXT);
		$yymain .= qq~
		<script language="JavaScript1.2" type="text/javascript">
			<!-- Begin
				var mnum = $INFO{'num'};
				var postnum = location.hash;
				var address = "$scripturl?num=";
				var start = $INFO{'start'};
				postnum = postnum.replace("#","");
				if(postnum >= $#msgtxt){start = 0; postnum = $#msgtxt;}
				else{postnum = $#msgtxt - postnum;}
				location.replace(address+mnum+"\;revpost=yes;start="+start+"#"+postnum);
			//-->
		</script>~;}
	### Reverse Post Order mod end ###


	my $viewnum = $INFO{'num'};

	# strip off any non numeric values to avoid exploitation
	$viewnum =~ s/(\D*)//ig;
	if ($viewnum !~ /\d*(.\d*)?/) { &fatal_error($display_txt{'337'}); }
	$maxmessagedisplay ||= 10;
	my ($buffer, $views, $lastposter, $moderators, $moderatorgroups, $counter, $counterwords, $pagedropindex, $msubthread, $mnum, $mstate, $mdate, $msub, $mname, $memail, $mreplies, $musername, $micon, $threadclass, $notify, $max, $start, $bgcolornum, $windowbg, $mattach, $mip, $mlm, $mlmb, $lastmodified, $postinfo, $star, $sendm, $topicdate);
	my (@messages, @bgcolors);

	&LoadCensorList;
	&LoadHotlinkList;

	# Determine category
	$curcat = ${$uid.$currentboard}{'cat'};

	# Figure out the name of the category
	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }

	if ($currentboard eq $annboard) {
		$vircurrentboard = $INFO{'virboard'};
		$vircurcat       = ${$uid.$vircurrentboard}{'cat'};
		($vircat, undef) = split(/\|/, $catinfo{"$vircurcat"});
		($virboardname, undef, undef) = split(/\|/, $board{"$vircurrentboard"});
		&ToChars($virboardname);
	}

	($cat, $catperms) = split(/\|/, $catinfo{"$curcat"});
	&ToChars($cat);

	($boardname, $boardperms, $boardview) = split(/\|/, $board{"$currentboard"});

	&ToChars($boardname);

	# Mark current thread as read.
	($mnum, $tmpa, $tmpa, $tmpa, $mdate) = split(/\|/, $yyThreadLine);
	&dumplog($mnum, $date);

	# Mark current board as read if called from Last Post.
	&BoardTotals("load", $currentboard);
	if ($mnum == ${$uid.$currentboard}{'lastpostid'}) {
		&getlog($currentboard);
		my $lastboardvisit = $yyuserlog{$currentboard} ? $yyuserlog{$currentboard} : 0;
		if ($mdate > $lastboardvisit) {
			&dumplog($currentboard);
		}
	}

	$views = ${$viewnum}{'views'} - 1;

	# Check to make sure this thread isn't locked.
	($mnum, $msubthread, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $yyThreadLine);
	$msubthread =~ s/\A\[m\]/$maintxt{'758'}/;

	# Look for a poll file for this thread.
	if (&AccessCheck($currentboard, 3) eq "granted") {
		$pollbutton = qq~$menusep<a href="$scripturl?action=post;num=$viewnum;title=AddPoll">$img{'addpoll'}</a>~;
	} else {
		$pollbutton = "";
	}
	if (-e "$datadir/$viewnum.poll") {
		$has_poll   = 1;
		$pollbutton = "";
	} else {
		$has_poll = 0;
		if ($useraddpoll == 0) { $pollbutton = ""; }
	}

	# Get the class of this thread, based on lock status and number of replies.
	if ($annboard eq $currentboard && !$iamadmin && !$iamgmod) {
		$replybutton = "";
	} elsif (&AccessCheck($currentboard, 2) eq "granted") {
		$replybutton = qq~$menusep<a href="$scripturl?action=post;num=$viewnum;title=PostReply">$img{'reply'}</a> ~;
	} else {
		$replybutton = "";
	}
	my $ishidden;
	$threadclass = 'thread';
	if ($mstate =~ /h/i) { $threadclass = 'hide'; $ishidden = 1; }
	elsif ($mstate =~ /l/i) { $threadclass = 'locked'; $replybutton = ""; $pollbutton  = ""; }
	elsif ($mreplies >= $VeryHotTopic) { $threadclass = 'veryhotthread'; }
	elsif ($mreplies >= $HotTopic) { $threadclass = 'hotthread'; }
	elsif ($mstate == "") { $threadclass = 'thread'; }

	if ($threadclass eq 'hide' && $mstate =~ /s/i && $mstate !~ /l/i) { $threadclass = 'hidesticky'; }
	elsif ($threadclass eq 'hide' && $mstate =~ /l/i && $mstate !~ /s/i) { $threadclass = 'hidelock'; $replybutton = ""; $pollbutton  = ""; }
	elsif ($threadclass eq 'hide' && $mstate =~ /s/i && $mstate =~ /l/i) { $threadclass = 'hidestickylock'; $replybutton = ""; $pollbutton  = ""; }
	elsif ($threadclass eq 'locked' && $mstate =~ /s/i && $mstate !~ /h/i) { $threadclass = 'stickylock'; }
	elsif ($mstate =~ /s/i && $mstate !~ /h/i) { $threadclass = 'sticky'; }
	elsif ($mstate =~ /a/i) { $threadclass = 'announcement'; $pollbutton = ""; }

	# Build a list of this board's moderators.
	$iammod = 0;
	if (scalar keys %moderators > 0) {
		if (scalar keys %moderators == 1) { $showmods = qq~($display_txt{'298'}: ~; }
		else { $showmods = qq~($display_txt{'63'}: ~; }
		while ($_ = each(%moderators)) {
			if ($username eq $_) { $iammod = 1; }
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}">$moderators{$_}</a>, ~;
		}
		$showmods =~ s/, \Z/)/;
	}
	if (scalar keys %moderatorgroups > 0) {
		&LoadUser($username);
		if (scalar keys %moderatorgroups == 1) { $showmodgroups = qq~($display_txt{'298a'}: ~; }
		else { $showmodgroups = qq~($display_txt{'63a'}: ~; }
		while ($_ = each(%moderatorgroups)) {
			if (${$uid.$username}{'position'} == $moderatorgroups{$_}) { $iammod = 1; }
			${$uid.$username}{'addgroups'} =~ s/\, /\,/g;
			foreach $memberaddgroups (split(/\,/, ${$uid.$username}{'addgroups'})) {
				chomp $memberaddgroups;
				if ($memberaddgroups == $moderatorgroups{$_}) { $iammod = 1; last; }
			}
			$tmpmodgrp = $moderatorgroups{$_};
			($thismodgrp, undef) = split(/\|/, $NoPost{$tmpmodgrp}, 2);
			$showmodgroups .= qq~$thismodgrp, ~;
		}
		$showmodgroups =~ s/, \Z/)/;
	}

	if ($ishidden && !$iammod && !$iamadmin && !$iamgmod) { &fatal_error("$maintxt{'1'}"); }

	if (-e "$datadir/$mnum.mail" && !$iamguest) {
		require "$sourcedir/Notify.pl";
		&ManageThreadNotify("update", $mnum, $username, "", "", "1");
	}

	if ($showmodgroups ne "" && $showmods ne "") { $showmods .= qq~ - ~; }
	if ($enable_notification) {
		my $startnum = $start || '0';
		$notify = qq~$menusep<a href="$scripturl?action=notify;thread=$viewnum/$startnum">$img{'notify'}</a>~;
	}

	# Build the page links list.
	if (!$iamguest) {
		(undef, $userthreadpage, undef) = split(/\|/, ${$uid.$username}{'pageindex'});
	}
	my ($pagetxtindex, $pagetextindex, $pagedropindex1, $pagedropindex2, $all, $allselected);
	$postdisplaynum = 3;               # max number of pages to display
	$dropdisplaynum = 10;
	$startpage      = 0;
	$max            = $mreplies + 1;
	if ($INFO{'start'} eq "all") { $maxmessagedisplay = $max; $all = 1; $allselected = qq~ selected="selected"~; $start = 0 }
	else { $start = $INFO{'start'} || 0; }
	$start    = $start > $mreplies ? $mreplies : $start;
	$start    = (int($start / $maxmessagedisplay)) * $maxmessagedisplay;
	$tmpa     = 1;
	$pagenumb = int(($max - 1) / $maxmessagedisplay) + 1;

	if ($start >= (($postdisplaynum - 1) * $maxmessagedisplay)) {
		$startpage = $start - (($postdisplaynum - 1) * $maxmessagedisplay);
		$tmpa = int($startpage / $maxmessagedisplay) + 1;
	}
	if ($max >= $start + ($postdisplaynum * $maxmessagedisplay)) { $endpage = $start + ($postdisplaynum * $maxmessagedisplay); }
	else { $endpage = $max; }
	$lastpn     = int($mreplies / $maxmessagedisplay) + 1;
	$lastptn    = ($lastpn - 1) * $maxmessagedisplay;
	$pageindex1 = qq~<span class="small" style="float: left; height: 21px; margin: 0px; margin-top: 2px;"><img src="$imagesdir/index_togl.gif" border="0" alt="" style="vertical-align: middle;" /> $display_txt{'139'}: $pagenumb</span>~;
	$pageindex2 = $pageindex1;
	if ($pagenumb > 1 || $all) {

		if ($userthreadpage == 1 || $iamguest) {
			$pagetxtindexst = qq~<span class="small" style="float: left; height: 21px; margin: 0px; margin-top: 2px;">~;
			if (!$iamguest) { $pagetxtindexst .= qq~<a href="$scripturl?num=$viewnum;start=$start;action=threadpagedrop"><img src="$imagesdir/index_togl.gif" border="0" alt="$display_txt{'19'}" style="vertical-align: middle;" /></a> $display_txt{'139'}: ~; }
			else { $pagetxtindexst .= qq~<img src="$imagesdir/index_togl.gif" border="0" alt="" style="vertical-align: middle;" /> $display_txt{'139'}: ~; }
			if ($startpage > 0) { $pagetxtindex = qq~<a href="$scripturl?num=$viewnum/0" style="font-weight: normal;">1</a>&nbsp;...&nbsp;~; }
			if ($startpage == $maxmessagedisplay) { $pagetxtindex = qq~<a href="$scripturl?num=$viewnum/0" style="font-weight: normal;">1</a>&nbsp;~; }
			for ($counter = $startpage; $counter < $endpage; $counter += $maxmessagedisplay) {
				$pagetxtindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?num=$viewnum/$counter" style="font-weight: normal;">$tmpa</a>&nbsp;~;
				$tmpa++;
			}
			if ($endpage < $max - ($maxmessagedisplay)) { $pageindexadd = qq~...&nbsp;~; }
			if ($endpage != $max) { $pageindexadd .= qq~<a href="$scripturl?num=$viewnum/$lastptn" style="font-weight: normal;">$lastpn</a>~; }
			$pagetxtindex .= qq~$pageindexadd~;
			$pageindex1 = qq~$pagetxtindexst$pagetxtindex</span>~;
			$pageindex2 = $pageindex1;
		} else {
			$pagedropindex1 = qq~<span style="float: left; width: 320px; margin: 0px; margin-top: 2px; border: 0px;">~;
			$pagedropindex1 .= qq~<span style="float: left; height: 21px; margin: 0; margin-right: 4px;"><a href="$scripturl?num=$viewnum;start=$start;action=threadpagetext"><img src="$imagesdir/index_togl.gif" border="0" alt="$display_txt{'19'}" /></a></span>~;
			$pagedropindex2 = $pagedropindex1;
			$tstart         = $start;
			if (substr($INFO{'start'}, 0, 3) eq "all") { ($tstart, $start) = split(/\-/, $INFO{'start'}); }
			$d_indexpages = $pagenumb / $dropdisplaynum;
			$i_indexpages = int($pagenumb / $dropdisplaynum);
			if ($d_indexpages > $i_indexpages) { $indexpages = int($pagenumb / $dropdisplaynum) + 1; }
			else { $indexpages = int($pagenumb / $dropdisplaynum) }
			$selectedindex = int(($start / $maxmessagedisplay) / $dropdisplaynum);

			if ($pagenumb > $dropdisplaynum) {
				$pagedropindex1 .= qq~<span style="float: left; height: 21px; margin: 0;"><select size="1" name="decselector1" id="decselector1" style="font-size: 9px; border: 2px inset;" onchange="if(this.options[this.selectedIndex].value) SelDec(this.options[this.selectedIndex].value, 'xx')">\n~;
				$pagedropindex2 .= qq~<span style="float: left; height: 21px; margin: 0;"><select size="1" name="decselector2" id="decselector2" style="font-size: 9px; border: 2px inset;" onchange="if(this.options[this.selectedIndex].value) SelDec(this.options[this.selectedIndex].value, 'xx')">\n~;
			}
			for ($i = 0; $i < $indexpages; $i++) {
				$indexpage  = ($i * $dropdisplaynum) * $maxmessagedisplay;
				$indexstart = ($i * $dropdisplaynum) + 1;
				$indexend   = $indexstart + ($dropdisplaynum - 1);
				if ($indexend > $pagenumb)    { $indexend   = $pagenumb; }
				if ($indexstart == $indexend) { $indxoption = qq~$indexstart~; }
				else { $indxoption = qq~$indexstart-$indexend~; }
				$selected = "";
				if ($i == $selectedindex) {
					$selected    = qq~ selected="selected"~;
					$pagejsindex = qq~$indexstart|$indexend|$maxmessagedisplay|$indexpage~;
				}
				if ($pagenumb > $dropdisplaynum) {
					$pagedropindex1 .= qq~<option value="$indexstart|$indexend|$maxmessagedisplay|$indexpage"$selected>$indxoption</option>\n~;
					$pagedropindex2 .= qq~<option value="$indexstart|$indexend|$maxmessagedisplay|$indexpage"$selected>$indxoption</option>\n~;
				}
			}
			if ($pagenumb > $dropdisplaynum) {
				$pagedropindex1 .= qq~</select>\n</span>~;
				$pagedropindex2 .= qq~</select>\n</span>~;
			}
			$pagedropindex1 .= qq~<span id="ViewIndex1" class="droppageindex" style="height: 14px; visibility: hidden">&nbsp;</span>~;
			$pagedropindex2 .= qq~<span id="ViewIndex2" class="droppageindex" style="height: 14px; visibility: hidden">&nbsp;</span>~;
			$tmpmaxmessagedisplay = $maxmessagedisplay;
			if (substr($INFO{'start'}, 0, 3) eq "all") { $maxmessagedisplay = $maxmessagedisplay * $dropdisplaynum; }
			$prevpage          = $start - $tmpmaxmessagedisplay;
			$nextpage          = $start + $maxmessagedisplay;
			$pagedropindexpvbl = qq~<img src="$imagesdir/index_left0.gif" height="14" width="13" border="0" alt="" style="margin: 0px; display: inline; vertical-align: middle;" />~;
			$pagedropindexnxbl = qq~<img src="$imagesdir/index_right0.gif" height="14" width="13" border="0" alt="" style="margin: 0px; display: inline; vertical-align: middle;" />~;
			if ($start < $maxmessagedisplay) { $pagedropindexpv .= qq~<img src="$imagesdir/index_left0.gif" height="14" width="13" border="0" alt="" style="display: inline; vertical-align: middle;" />~; }
			else { $pagedropindexpv .= qq~<img src="$imagesdir/index_left.gif" border="0" height="14" width="13" alt="$pidtxt{'02'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?num=$viewnum/$prevpage\\'" ondblclick="location.href=\\'$scripturl?num=$viewnum/0\\'" />~; }
			if ($nextpage > $lastptn) { $pagedropindexnx .= qq~<img src="$imagesdir/index_right0.gif" border="0" height="14" width="13" alt="" style="display: inline; vertical-align: middle;" />~; }
			else { $pagedropindexnx .= qq~<img src="$imagesdir/index_right.gif" height="14" width="13" border="0" alt="$pidtxt{'03'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?num=$viewnum/$nextpage\\'" ondblclick="location.href=\\'$scripturl?num=$viewnum/$lastptn\\'" />~; }
			$pageindex1 = qq~$pagedropindex1</span>~;
			$pageindex2 = qq~$pagedropindex2</span>~;

			$pageindexjs = qq~
	function SelDec(decparam, visel) {
		splitparam = decparam.split("|");
		var vistart = parseInt(splitparam[0]);
		var viend = parseInt(splitparam[1]);
		var maxpag = parseInt(splitparam[2]);
		var pagstart = parseInt(splitparam[3]);
		var allpagstart = parseInt(splitparam[3]);
		if(visel == 'xx' && decparam == '$pagejsindex') visel = '$tstart';
		var pagedropindex = '<table border="0" cellpadding="0" cellspacing="0"><tr>';
		for(i=vistart; i<=viend; i++) {
			if(visel == pagstart) pagedropindex += '<td class="titlebg" height="14" style="height: 14px; padding-left: 1px; padding-right: 1px; font-size: 9px; font-weight: bold;">' + i + '</td>';
			else pagedropindex += '<td height="14" class="droppages"><a href="$scripturl?num=$viewnum/' + pagstart + '">' + i + '</a></td>';
			pagstart += maxpag;
		}
		if (vistart != viend) {
			if(visel == 'all') pagedropindex += '<td class="titlebg" height="14" style="height: 14px; padding-left: 1px; padding-right: 1px; font-size: 9px; font-weight: normal;"><b>$pidtxt{"01"}</b></td>';
			else pagedropindex += '<td height="14" class="droppages"><a href="$scripturl?num=$viewnum/all-' + allpagstart + '">$pidtxt{"01"}</a></td>';
		}
		if(visel != 'xx') pagedropindex += '<td height="14" class="small" style="height: 14px; padding-left: 4px;">$pagedropindexpv$pagedropindexnx</td>';
		else pagedropindex += '<td height="14" class="small" style="height: 14px; padding-left: 4px;">$pagedropindexpvbl$pagedropindexnxbl</td>';
		pagedropindex += '</tr></table>';
		document.getElementById("ViewIndex1").innerHTML=pagedropindex;
		document.getElementById("ViewIndex1").style.visibility = "visible";
		document.getElementById("ViewIndex2").innerHTML=pagedropindex;
		document.getElementById("ViewIndex2").style.visibility = "visible";
		~;
			if ($pagenumb > $dropdisplaynum) {
				$pageindexjs .= qq~
		document.getElementById("decselector1").value = decparam;
		document.getElementById("decselector2").value = decparam;
		~;
			}
			$pageindexjs .= qq~
	}
	document.onload = SelDec('$pagejsindex', '$tstart');
~;
		}
	}

	$msubthread   = &Censor($msubthread);
	$curthreadurl = qq~$msubthread~;
	&ToChars($curthreadurl);

	$yymain .= qq~
		<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
	~;

	# Insert Navigation Bit
	$prevlink = "";
	$nextlink = "";
	&NextPrev($viewnum);
	$template_prev    = qq~$prevlink~;
	$template_next    = qq~$nextlink~;
	$template_home    = qq~<a href="$scripturl" class="nav">$mbname</a>~;
	$template_viewers = "";
	$topviewers       = 0;

	if ($annboard ne "" && $currentboard eq $annboard) {
		if ($vircurrentboard) {
			$template_cat   = qq~<a href="$scripturl?catselect=$vircurcat" class="nav">$vircat</a>~;
			$template_board = qq~<a href="$scripturl?board=$vircurrentboard" class="nav">$virboardname</a>~;
			$template_mods  = qq~$showmods$showmodgroups~;
		} elsif ($iamadmin || $iamgmod) {
			$template_cat   = qq~<a href="$scripturl?catselect=$curcat" class="nav">$cat</a>~;
			$template_board = qq~<a href="$scripturl?board=$currentboard" class="nav">$boardname</a>~;
			$template_mods  = qq~$showmods$showmodgroups~;
		} else {
			$template_cat   = qq~$maintxt{'418'}~;
			$template_board = qq~$security_txt{'999'}~;
			$template_mods  = "";
		}
	} else {
		$template_cat   = qq~<a href="$scripturl?catselect=$curcat" class="nav">$cat</a>~;
		$template_board = qq~<a href="$scripturl?board=$currentboard" class="nav">$boardname</a>~;
		$template_mods  = qq~$showmods$showmodgroups~;
		if ($showtopicviewers && (($iamadmin || $iamgmod || $iammod) && $sessionvalid == 1)) {
			foreach $thisreplier (@repliers) {
				chomp $thisreplier;
				$replying = "";
				(undef, $mrepuser, $misreplying) = split(/\|/, $thisreplier);
				&LoadUser($mrepuser);
				if ($misreplying) { $replying = qq~ <span class="small">($display_txt{'645'})</span>~; }
				$template_viewers .= qq~$link{$mrepuser}$replying, ~;
				$topviewers++;
			}
			$template_viewers =~ s/\, \Z/\./;
		}

	}
	if ($template_mods) { $template_mods = qq~<br />$template_mods~; }

	# Insert 0
	unless (($enable_guestposting == 0 && $iamguest) || $annboard eq $currentboard) {
		$template_poll = qq~$pollbutton~;
	}
	if (!$iamguest) {
		if ($annboard ne "" && $currentboard eq $annboard) {
			$template_favorite = "";
		} else {
			require "$sourcedir/Favorites.pl";
			$template_favorite .= &IsFav($viewnum, $start);
		}
		$template_notify = $notify;
	} else {
		$template_favorite = "";
		$template_notify   = "";
	}
	$template_threadimage = qq~<a name="top"><img src="$imagesdir/$threadclass.gif" style="vertical-align: middle;" alt="" /></a>~;
	$template_sendtopic   = qq~$menusep<a href="$scripturl?action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>~;
	$template_print       = qq~$menusep<a href="$scripturl?action=print;num=$viewnum" target="_blank">$img{'print'}</a>~;
	$template_pollmain    = "";
	if ($has_poll) { require "$sourcedir/Poll.pl"; &display_poll($viewnum); $template_pollmain = qq~$pollmain<br />~; }

	# Load background color list.
	@bgcolors   = ($color{windowbg}, $color{windowbg2});
	$bgcolornum = scalar @bgcolors;
	@cssvalues  = ("windowbg", "windowbg2");
	$cssnum     = scalar @bgcolors;

	if (!$MenuType) { $sm = 1; }
	$counter    = 0;
	$avacounter = 0;

	fopen(MSGTXT, "$datadir/$viewnum.txt") || &fatal_error("104 $display_txt{'106'}: $display_txt{'23'} $viewnum.txt", 1);

	### Reverse Post Order mod ###
	@msgtxt = <MSGTXT>;
	fclose(MSGTXT);
	if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') { @msgtxt = reverse(@msgtxt); }
	for($counter = $start; ($counter < $maxmessagedisplay + $start) && ($counter <= $#msgtxt); $counter++) {
		push (@messages, $msgtxt[$counter]);}
	$counter = $start;

	if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') {$counter = $#msgtxt - $start;}
	### Reverse Post Order end ###

	# For each post in this thread:
	foreach (@messages) {
		$windowbg = $bgcolors[($counter % $bgcolornum)];
		$css      = $cssvalues[($counter % $cssnum)];
		$revcss   = $cssvalues[($counter % $cssnum - 1)];
		chomp;
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb, $mfn) = split(/[\|]/, $_);
		$msub =~ s/\A\[m\]/$maintxt{'758'}/;

		# Should we show an attachment file?
		if($mfn && $mfn ne "") {
			unless (-d "$uploaddir/log") { mkdir "$uploaddir/log",0755;} 
			if(-e ("$uploaddir/log/$mfn.cnt")) {
				 open(COUNT, "$uploaddir/log/$mfn.cnt");
				 $count = <COUNT>;
				 close(COUNT);
				 chomp $count;
				 if($count > 0) { $dcounter = qq~($count $fatxt{'49a'})~; } else { $dcounter = ""; }
			} else { $dcounter = ""; }

			if (-e ("$uploaddir/$mfn")) {
				$attachment = qq~<span class="small"><a href="$scripturl?action=download;file=$mfn" target="_blank"><img src="$imagesdir/paperclip.gif" border="0" align="middle" alt="" /> $mfn</a> $dcounter</span>~;
				if(($mfn =~ /(jpg|gif|bmp|png|jpeg)$/i) && ($amdisplaypics == 1)) {
					$showattach = qq~<div class="scroll" style="max-height: 400px; width: 100%; overflow: auto;" align="center"><img src="$uploadurl/$mfn" alt="$mfn" border="0" /></div>~;
					$showattachhr = qq~<hr width="100%" size="1" class="hr" style="margin: 0; margin-top: 5px; margin-bottom: 5px; padding: 0;" />~;
				} else { 
					$showattach   = '';
					$showattachhr = '';
				}
			} else {
				$attachment   = qq~<span class="small"><img src="$imagesdir/paperclip.gif" border="0" align="middle" alt="" />  $mfn $fatxt{'1'}</span>~;
				$showattach   = '';
				$showattachhr = '';
			}
		} else {
			$attachment   = '';
			$showattach   = '';
			$showattachhr = '';
		}

		# Should we show "last modified by?"
		if ($mlm && $showmodify && $mlm ne "" && $mlmb ne "") {
			if ($tllastmodflag) {
				$tllastmodtimesecs = $tllastmodtime * 60;
				$tlmesstime        = $mdate + $tllastmodtimesecs;
				$tllasttime        = $mlm;
				if ($tlmesstime > $tllasttime) {
					$mlm          = '-';
					$lastmodified = '';
				} else {
					$mlm = &timeformat($mlm);
					&LoadUser($mlmb);
					$mlmb = ${$uid.$mlmb}{'realname'} || $mlmb || $display_txt{'470'};
					$lastmodified = qq~&#171; <i>$display_txt{'211'}: $mlm $display_txt{'525'} $mlmb</i> &#187;~;
				}
			} else {
				$mlm = &timeformat($mlm);
				&LoadUser($mlmb);
				$mlmb = ${$uid.$mlmb}{'realname'} || $mlmb || $display_txt{'470'};
				$lastmodified = qq~&#171; <i>$display_txt{'211'}: $mlm $display_txt{'525'} $mlmb</i> &#187;~;
			}
		} else {
			$mlm          = '-';
			$lastmodified = '';
		}
		if ($tlnomodflag) {
			unless (($iamadmin || $iamgmod || $iammod) && $sessionvalid == 1) {
				$tlnomodtimesecs = $tlnomodtime * 3600 * 24;
				$tltime          = $mdate + $tlnomodtimesecs;
				$tlcurrenttime   = $date;
				if ($tlcurrenttime > $tltime) {
					$nomodallowed = 1;
				} else {
					$nomodallowed = 0;
				}
			}
		}
		if ($tlnodelflag) {
			unless (($iamadmin || $iamgmod || $iammod) && $sessionvalid == 1) {
				$tlnodeltimesecs = $tlnodeltime * 3600 * 24;
				$tldtime         = $mdate + $tlnodeltimesecs;
				$tldcurrenttime  = $date;
				if ($tldcurrenttime > $tldtime) {
					$nodelallowed = 1;
				} else {
					$nodelallowed = 0;
				}
			}
		}
		$msub ||= $display_txt{'24'};
		$messdate = &timeformat($mdate);
## start link IP mod - define $iplink ##
	    if($iputil eq 0){$iputil = 'ptr';}
	    if($iputil eq 1){$iputil = 'whois';}
	    if($iputil eq 2){$iputil = 'city';}
	    if($iputil eq 3){$iputil = 'tracert';}
   	    $iplink = qq~<a href="http://www.dnsstuff.com/tools/$iputil.ch?ip=$mip" target="_blank" style="text-decoration: underline;">$mip</a>~;
		if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq "on") { $mip = $iplink }
## end link IP mod ##
		else { $mip = "$display_txt{'511'}"; }
		$sendm = '';

		# If the user isn't a guest, load their info.
		if ($musername ne 'Guest' && !$yyUDLoaded{$musername} && -e ("$memberdir/$musername.vars")) {
			&LoadUserDisplay($musername);
		}
		$messagedate = $mdate;
		if (${$uid.$musername}{'regtime'}) {
			$registrationdate = ${$uid.$musername}{'regtime'};
		} else {
			$registrationdate = int(time);
		}

		if (${$uid.$musername}{'signature'}) {
			$signature_hr = qq~<hr width="100%" size="1" class="hr" style="margin: 0; margin-top: 5px; margin-bottom: 5px; padding: 0;" />~;
		} else {
			$signature_hr = "";
		}
		$exmem = 0;
		my ($aimad, $yimad, $msnad, $gtalkad, $xfiread, $icqad);
		if ((${$uid.$musername}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$musername}{'status'} eq "Administrator" || ${$uid.$musername}{'status'} eq "Global Moderator") {
			$displayname = ${$uid.$musername}{'realname'};
			$star        = $memberstar{$musername};
			if($location_posts) {
				($loctxt, $locflag) = split (/\|/, ${$uid.$username}{'viewlocation'});
				if($locflag || $loctxt) {$star .= qq~<br />~;}
				if($locflag) {
					if(${$uid.$musername}{'xcoord'}) {
						$locationlabel = qq~${$uid.$musername}{'location'}~;
						if(${$uid.$musername}{'state'}) {
							(undef, $tmpstate) = split(/\,/, ${$uid.$musername}{'state'});
							$locationlabel .= qq~, $tmpstate~;
						}
						if(${$uid.$musername}{'country'}) {$locationlabel .= qq~, ${$uid.$musername}{'country'}~;}
						$locationlabel =~ s/\_/ /g;
						$star .= qq~<br /><a href="$scripturl?action=viewlocation;username=$musername"><img src="$modimgurl/yamms/flag/${$uid.$musername}{'country'}.gif" border="0" alt="$locationlabel" /></a>~;
					}
				}
				if($loctxt) {
					if(${$uid.$musername}{'xcoord'}) {
						$locationlabel = qq~${$uid.$musername}{'location'}~;
						if(${$uid.$musername}{'state'}) {
							(undef, $tmpstate) = split(/\,/, ${$uid.$musername}{'state'});
							$locationlabel .= qq~<br />$tmpstate~;
						}
						if(${$uid.$musername}{'country'}) {$locationlabel .= qq~<br />${$uid.$musername}{'country'}~;}
						$locationlabel =~ s/\_/ /g;
						$star .= qq~<br /><a href="$scripturl?action=viewlocation;username=$musername" class="small">$locationlabel</a>~;
					}
				}
			}
			$memberinfo  = "$memberinfo{$musername}$addmembergroup{$musername}";
			$memberinfo =~ s~\n~~g;

			if (${$uid.$musername}{'aim'}) { $aimad = qq~$menusep${$uid.$musername}{'aim'}~; }
			if (${$uid.$musername}{'icq'}) { $icqad = qq~$menusep${$uid.$musername}{'icq'}~; }
			if (${$uid.$musername}{'yim'}) { $yimad = qq~$menusep${$uid.$musername}{'yim'}~; }

			if (${$uid.$musername}{'msn'})   { $msnad   = qq~$menusep${$uid.$musername}{'msn'}~; }
			if (${$uid.$musername}{'gtalk'}) { $gtalkad = qq~$menusep${$uid.$musername}{'gtalk'}~; }
			if (${$uid.$musername}{'xfire'}) { $xfiread = qq~$menusep${$uid.$musername}{'xfire'}~; }
			if (${$uid.$musername}{'skype'}) { $skypead = qq~$menusep${$uid.$musername}{'skype'}~; }

			if (!$iamguest) {

				# Allow instant message sending if current user is a member.
				$sendm = qq~$menusep<a href="$scripturl?action=imsend;to=$useraccount{$musername}">$img{'message_sm'}</a>~;
			}
			$online = qq~<img src="$defaultimagesdir/red1.gif" />~;
			fopen(FILE, "$vardir/log.txt");
			@entries = <FILE>;
			fclose(FILE);
			foreach $curentry (@entries) {
			chomp $curentry;
			($name, $value) = split(/\|/, $curentry);
			if($name eq $musername && ${$uid.$name}{'hide_me'} ne "on") {
				$online = qq~<img src="$defaultimagesdir/green1.gif" />~;	
				}
			}
			$usernamelink = qq~$online $link{$musername}<br />~;
			require "$sourcedir/ExtendedProfiles.pl";
			$usernamelink = ext_viewinposts_popup($musername,$usernamelink);
			$postinfo     = qq~$display_txt{'21'}: ${$uid.$musername}{'postcount'}<br />~;
			$memail       = qq~$scripturl?action=mailto;user=$musername~;
		} elsif ($musername !~ m~Guest~ && $messagedate < $registrationdate) {
			$exmem        = 1;
			$star         = '';
			$memberinfo   = $display_txt{'470a'};
			$icqad        = '';
			$yimad        = '';
			$xfiread      = '';
			$skypead      = '';
			$usernamelink = qq~<b>$mname</b><br />~;
			if ($memberinfo eq "$display_txt{'28'}") { $usernamelink = qq~<b>$mname</b><br />~; }
			$postinfo    = '';
			$displayname = $display_txt{'470a'};
		} else {
			$musername    = "Guest";
			$star         = '';
			$memberinfo   = "$display_txt{'28'}";
			$icqad        = '';
			$yimad        = '';
			$xfiread      = '';
			$skypead      = '';
			$usernamelink = qq~<b>$mname</b>~;
			if ($memberinfo eq "$display_txt{'28'}") { $usernamelink = qq~<b>$mname</b><br />~; }
			$postinfo    = '';
			$displayname = $mname;
			$cryptmail   = &scramble($memail, $musername);
			$memail      = qq~$scripturl?action=mailto;user=$musername;mail_id=$cryptmail~;
		}

		# Censor the subject and message.
		$postmessage = &Censor($postmessage);
		$msub        = &Censor($msub);
		&ToChars($msub);

		# Run UBBC interpreter on the message.
		$message = $postmessage;
		&wrap;
		if ($enable_ubbc) {
			if (!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
			&DoUBBC;
		}
		&wrap2;
		&ToChars($message);
		if($hot_post) {
			$hotmessage = $message;
			&ConvHotlink;
			$message = $hotmessage;
		}


		$profbutton = $profilebutton && $musername ne 'Guest' ? qq~$menusep<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$img{'viewprofile_sm'}</a>~ : '';
		if ($counter != 0) { $counterwords = "$display_txt{'146'} #$counter - "; }
		else { $counterwords = ""; }

		# Print the post and user info for the poster.
		my $outblock        = $messageblock;
		my $posthandelblock = $posthandellist;
		my $contactblock    = $contactlist;

		if ($mstate !~ /l/i) {
			unless (($enable_guestposting == 0 && $iamguest) || &AccessCheck($currentboard, 2) ne "granted" || ($annboard eq $currentboard && !$iamadmin && !$iamgmod)) {
				$template_quote = qq~$menusep<a href="$scripturl?action=post;num=$viewnum;quote=$counter;title=PostReply">$img{'replyquote'}</a>~;
			}
			if ($iammod || $iamadmin || $iamgmod || ($username eq $musername && !$iamguest && !$exmem && $nomodallowed == 0) && $sessionvalid == 1) {
				$template_modify = qq~$menusep<a href="$scripturl?board=$currentboard;action=modify;message=$counter;thread=$viewnum">$img{'modify'}</a>~;
			} else {
				$template_modify = "";
			}
			if ($counter > 0 && ($iammod || $iamadmin || $iamgmod) && $sessionvalid == 1) {
				$template_split = qq~$menusep<a href="$scripturl?board=$currentboard;action=split2;thread=$viewnum;postid=$counter">$img{'admin_split'}</a>~;
			}
			if ($iammod || $iamadmin || $iamgmod || ($username eq $musername && !$iamguest && !$exmem && $nodelallowed == 0) && $sessionvalid == 1) {
				$template_delete = qq~$menusep<span style="cursor: pointer; cursor: hand;" onclick="uncheckAllBut($counter);">$img{'delete'}</span>~;

				if (($iammod && $mdmod eq 1) || ($iamadmin && $mdadmin eq 1) || ($iamgmod && $mdglobal eq 1) && $sessionvalid == 1) {
					$template_admin = qq~<input type="checkbox" class="$css" style="border: 0px;" name="del$counter" value="$counter" />~;
				} else {
					$template_admin = qq~ <input type="checkbox" class="$css" style="border: 0px; visibility: hidden; display: none;" name="del$counter" value="$counter" />~;
				}
			} else {
				$template_delete = "";
				$template_admin  = qq~ <input type="checkbox" class="$css" style="border: 0px; visibility: hidden; display: none;" name="del$counter" value="$counter" />~;
			}
		}

		# Insert 3
		if (!$exmem && $musername ne "Guest" && -e "$memberdir/$musername.vars") {
			$template_userpic  = qq~${$uid.$musername}{'userpic'}~;
			$template_usertext = qq~${$uid.$musername}{'usertext'}~;
			$template_postinfo = qq~$postinfo~;
			$template_gender   = qq~${$uid.$musername}{'gender'}~;
			if ($showuserpic && $allowpics) {
				if (${$uid.$musername}{'userownpic'}) {
					$avstyle = "";
					if ($ENV{'HTTP_USER_AGENT'} !~ /MSIE/ || $ENV{'HTTP_USER_AGENT'} =~ /Opera/) {
						if ($userpic_width > 0 || $userpic_height > 0) {
							$avstyle = qq~ style="~;
							if ($userpic_width > 0)  { $avstyle .= qq~max-width: $userpic_width\px\; ~; }
							if ($userpic_height > 0) { $avstyle .= qq~max-height: $userpic_height\px\;~; }

							# Limit avatar widths/heights for safari - since Safari contains a bug
							# regarding max-width, and height when only one is present.
							# http://bugzilla.opendarwin.org/show_bug.cgi?id=5146
							if (($userpic_height == 0 && $userpic_width > 0)  && $ENV{'HTTP_USER_AGENT'} =~ /Safari/) { $avstyle .= qq~max-height: $userpic_width\px\;~; }
							if (($userpic_width == 0  && $userpic_height > 0) && $ENV{'HTTP_USER_AGENT'} =~ /Safari/) { $avstyle .= qq~max-width: $userpic_height\px\;~; }

							$avstyle .= qq~"~;
						}
						$avatar = qq~<img src="$template_userpic" alt="" border="0"$avstyle /><br />~;
					} else {
						$avatar = qq~
				<script language="JavaScript1.2" type="text/javascript">
				<!-- //
					var userpic_width = $userpic_width;
					var userpic_height = $userpic_height;
					imgEle$counter = new Image();
					imgEle$counter.src = "$template_userpic";

					if(imgEle$counter.width) {
						if (userpic_width == 0) { tmpuserpic_width = imgEle$counter.width; } else {tmpuserpic_width = userpic_width;}
						if (userpic_height == 0) { tmpuserpic_height = imgEle$counter.height; } else {tmpuserpic_height = userpic_height;}
						var ratio = imgEle$counter.width / imgEle$counter.height;
						for(z=0;z<2;z++) { 
							if (imgEle$counter.width > tmpuserpic_width) { imgEle$counter.width = tmpuserpic_width; imgEle$counter.height = parseInt(imgEle$counter.width / ratio); }    
							if (imgEle$counter.height > tmpuserpic_height) { imgEle$counter.height = tmpuserpic_height; imgEle$counter.width = parseInt(imgEle$counter.height * ratio); }
						}
						document.write('<img src=" ' + imgEle$counter.src + ' " width=" ' + imgEle$counter.width + ' " height=" ' + imgEle$counter.height + ' " alt="" border="0" /><br />');
					}
					else {
						if (userpic_width == 0) { tmpuserpic_width = 65; } else {tmpuserpic_width = userpic_width;}
						document.write('<img src="$template_userpic" width=" ' + tmpuserpic_width + ' " alt="" border="0" /><br />');
					}
				// -->
				</script>
				<noscript>
				~;
						if ($userpic_width > 0 || $userpic_height > 0) {
							$avstyle = qq~ style="~;
							if ($userpic_width > 0) { $avstyle .= qq~width: $userpic_width\px\;~; }
							$avstyle .= qq~"~;
						}
						$avatar .= qq~<img src="$template_userpic" alt="" border="0"$avstyle /><br />
				</noscript>
				~;
					}
					$avacounter++;
				} else {
					$avatar = qq~<img src="$template_userpic" alt="" border="0" /><br />~;
				}
			} else {
				$avatar = qq~$template_userpic~;
			}
		}

		# Insert 2
		if ((${$uid.$musername}{'hidemail'} ne "checked" || $iamadmin || $iamgmod || $allow_hide_email ne 1) && $exmem == 0) {
			$template_email   = qq~$menusep<a href="$memail" target="_blank">$img{'email_sm'}</a>~;
			$template_profile = qq~$profbutton~;
			$template_pm      = qq~$sendm~;
			$template_www     = ${$uid.$musername}{'weburl'} ? qq~$menusep${$uid.$musername}{'weburl'}~ : '';
		} else {
			$template_email   = qq~~;
			$template_profile = qq~$profbutton~;
			$template_pm      = qq~$sendm~;
			$template_www     = ${$uid.$musername}{'weburl'} ? qq~$menusep${$uid.$musername}{'weburl'}~ : '';
		}
		if ($musername eq "Guest") {
			$template_email    = qq~$menusep<a href="$memail" target="_blank">$img{'email_sm'}</a>~;
			$template_userpic  = "";
			$template_usertext = "";
			$template_postinfo = "";
			$template_gender   = "";
			$avatar            = "";
		}
		if ($exmem == 1) {
			$template_userpic  = "";
			$template_usertext = "";
			$template_postinfo = "";
			$template_gender   = "";
			$avatar            = "";
			$template_profile  = "";
			$icqad             = '';
			$yimad             = '';
			$aimad             = '';
			$msnad             = '';
			$gtalkad           = '';
			$xfiread           = '';
			$skypead           = '';
		}

		$msgimg = qq~<a href="$scripturl?num=$viewnum/$counter#$counter"><img src="$imagesdir/$micon.gif" alt="" border="0" style="vertical-align: middle;" /></a>~;
		$ipimg  = qq~<img src="$imagesdir/ip.gif" alt="" border="0" style="vertical-align: middle;" />~;
		require "$sourcedir/ExtendedProfiles.pl";
		$template_gender .= ext_viewinposts($musername);

		$posthandelblock =~ s/<yabb quote>/$template_quote/g;
		$posthandelblock =~ s/<yabb modify>/$template_modify/g;
		$posthandelblock =~ s/<yabb split>/$template_split/g;
		$posthandelblock =~ s/<yabb delete>/$template_delete/g;
		$posthandelblock =~ s/<yabb admin>/$template_admin/g;
		$posthandelblock =~ s/\Q$menusep//i;

		$contactblock =~ s/<yabb email>/$template_email/g;
		$contactblock =~ s/<yabb profile>/$template_profile/g;
		$contactblock =~ s/<yabb pm>/$template_pm/g;
		$contactblock =~ s/<yabb www>/$template_www/g;
		$contactblock =~ s/<yabb aim>/$aimad/g;
		$contactblock =~ s/<yabb yim>/$yimad/g;
		$contactblock =~ s/<yabb icq>/$icqad/g;
		$contactblock =~ s/<yabb msn>/$msnad/g;
		$contactblock =~ s/<yabb gtalk>/$gtalkad/g;
		$contactblock =~ s/<yabb xfire>/$xfiread/g;
		$contactblock =~ s/<yabb skype>/$skypead/g;
		$contactblock =~ s/\Q$menusep//i;

		$outblock =~ s/<yabb images>/$imagesdir/g;
		$outblock =~ s/<yabb messageoptions>/$msgcontrol/g;
		$outblock =~ s/<yabb memberinfo>/$memberinfo/g;
		$outblock =~ s/<yabb userlink>/$usernamelink/g;
		$outblock =~ s/<yabb stars>/$star/g;
		$outblock =~ s/<yabb subject>/$msub/g;
		$outblock =~ s/<yabb msgimg>/$msgimg/g;
		$outblock =~ s/<yabb msgdate>/$messdate/g;
		$outblock =~ s/<yabb replycount>/$counterwords/g;
		$outblock =~ s/<yabb count>/$counter/g;
		$outblock =~ s/<yabb att>/$attachment/g;
		$outblock =~ s/<yabb css>/$css/g;
		$outblock =~ s/<yabb gender>/$template_gender/g;
		$outblock =~ s/<yabb postinfo>/$template_postinfo/g;
		$outblock =~ s/<yabb usertext>/$template_usertext/g;
		$outblock =~ s/<yabb userpic>/$avatar/g;
		$outblock =~ s/<yabb message>/$message/g;
		$outblock =~ s/<yabb showatt>/$showattach/g;
		$outblock =~ s/<yabb showatthr>/$showattachhr/g;
		$outblock =~ s/<yabb modified>/$lastmodified/g;
		$outblock =~ s/<yabb signature>/${$uid.$musername}{'signature'}/g;
		$outblock =~ s/<yabb signaturehr>/$signature_hr/g;
		$outblock =~ s/<yabb ipimg>/$ipimg/g;
		$outblock =~ s/<yabb ip>/$mip/g;
		$outblock =~ s/<yabb posthandellist>/$posthandelblock/g;
		$outblock =~ s/<yabb contactlist>/$contactblock/g;
		$tmpoutblock .= $outblock;

		### Reverse Post Order ###
		if (${$uid.$username}{'reverse_posts'} eq "on" && $threadclass ne 'announcement') {$counter--;}
		else {$counter++;}
		### Reverse Post Order end ###		
	}
	# Insert 4

	# Insert 5
	my ($template_move, $template_remove, $template_splice, $template_lock, $template_hide, $template_sticky, $template_multidelete);
	if (($iammod || $iamadmin || $iamgmod) && $sessionvalid == 1) {
		$template_move   = qq~$menusep<a href="$scripturl?action=movethread;thread=$viewnum">$img{'admin_move'}</a>~;
		$template_remove = qq~$menusep<a href="javascript:document.removethread.submit();" onclick="return confirm('$display_txt{'162'}')"> $img{'admin_rem'}</a>~;

		# board=$currentboard is necessary for splicing DO NOT REMOVE!
		$template_splice = qq~$menusep<a href="$scripturl?board=$currentboard;action=splice;thread=$viewnum">$img{'admin_splice'}</a>$menusep<a href="$scripturl?cat=$curcat;board=$currentboard;action=split_splice_adv;thread=$viewnum"><img src="$modimgurl/Split_Splice_Adv/split_splice_button_$language.$imgext" border="0" /></a>~; ## Split Splice Advanced mod ##

		$template_lock   = qq~$menusep<a href="$scripturl?action=lock;thread=$viewnum">$img{'admin_lock'}</a>~;
		$template_hide   = qq~$menusep<a href="$scripturl?action=hide;thread=$viewnum">$img{'hide'}</a>~;
		$template_sticky = qq~$menusep<a href="$scripturl?action=sticky;thread=$viewnum">$img{'admin_sticky'}</a>~;
		if ($mstate =~ /a/i) { $template_lock = ""; $template_hide = ""; $template_sticky = ""; }
	}
	if (($iammod && $mdmod eq 1) || ($iamadmin && $mdadmin eq 1) || ($iamgmod && $mdglobal eq 1) && $sessionvalid == 1) {
		if ($mstate !~ /l/i) {
			$template_multidelete = qq~$menusep<a href="javascript:document.multidel.submit();">$img{'admin_del'}</a>~;
		}
	}

	if ($template_viewers) {
		$topic_viewers = qq~
	<tr>
		<td class="windowbg" valign="middle" align="left">
			$display_txt{'644'} ($topviewers): $template_viewers
		</td>
	</tr>
~;
	}

	# Mark as read button has no use in global announcements or for guests
	if ($currentboard ne $annboard && !$iamguest) {
		$mark_unread = qq~$menusep<a href="$scripturl?action=markunread;thread=$viewnum;board=$currentboard">$img{'markunread'}</a>~;
	} else {
		$mark_unread = "";
	}

	&jumpto;

	if ($pboard{"$currentboard"} ne "") {
		my @parents = ();
		@parents = split(/\|/, $pboard{"$currentboard"});
		$parentboards = "";
		foreach $parent (@parents) {
			($parent_name, $trash, $trash) = split(/\|/, $board{"$parent"});
			$parentboards .= qq~<a href="$scripturl?board=$parent" class="nav">$parent_name</a>$parentseparator~;
		}
	} else { $parentboards = ""; }

	# Template it
	$threadhandellist =~ s/<yabb markunread>/$mark_unread/g;
	$threadhandellist =~ s/<yabb reply>/$replybutton/g;
	$threadhandellist =~ s/<yabb poll>/$template_poll/g;
	$threadhandellist =~ s/<yabb notify>/$template_notify/g;
	$threadhandellist =~ s/<yabb favorite>/$template_favorite/g;
	$threadhandellist =~ s/<yabb sendtopic>/$template_sendtopic/g;
	$threadhandellist =~ s/<yabb print>/$template_print/g;
	$threadhandellist =~ s/\Q$menusep//i;

	$adminhandellist =~ s/<yabb move>/$template_move/g;
	$adminhandellist =~ s/<yabb remove>/$template_remove/g;
	$adminhandellist =~ s/<yabb splice>/$template_splice/g;
	$adminhandellist =~ s/<yabb lock>/$template_lock/g;
	$adminhandellist =~ s/<yabb hide>/$template_hide/g;
	$adminhandellist =~ s/<yabb sticky>/$template_sticky/g;
	$adminhandellist =~ s/<yabb multidelete>/$template_multidelete/g;
	$adminhandellist =~ s/\Q$menusep//i;

	$display_template =~ s/<yabb home>/$template_home/g;
	$display_template =~ s/<yabb category>/$template_cat/g;
	$display_template =~ s/<yabb parentboards>/$parentboards/g;
	$display_template =~ s/<yabb board>/$template_board/g;
	$display_template =~ s/<yabb moderators>/$template_mods/g;
	$display_template =~ s/<yabb topicviewers>/$topic_viewers/g;
	$display_template =~ s/<yabb prev>/$template_prev/g;
	$display_template =~ s/<yabb next>/$template_next/g;
	$display_template =~ s/<yabb pageindex top>/$pageindex1/g;
	$display_template =~ s/<yabb pageindex bottom>/$pageindex2/g;

	$display_template =~ s/<yabb threadhandellist>/$threadhandellist/g;
	$display_template =~ s/<yabb threadimage>/$template_threadimage/g;
	$display_template =~ s/<yabb threadurl>/$curthreadurl/g;
	$display_template =~ s/<yabb views>/$views/g;
	if ($username eq $poll_uname || ($iammod || $iamadmin || $iamgmod && $sessionvalid == 1)) {
		if ($mstate !~ /l/i) {
			# Only put poll form in if has a poll...
			if (-e "$datadir/$viewnum.poll") {
				$formstart .= qq~<form name="removepoll" action="$scripturl?action=modify2;d=1" method="post" style="display: inline">
				<input type="hidden" name="thread" value="$viewnum" />
				<input type="hidden" name="id" value="Poll" />
				</form>~;
			}
		}

		# Board=$currentboard is necessary for multidel - DO NOT REMOVE!!
		# This form is necessary to allow thread deletion in locked topics.
		$formstart .= qq~<form name="removethread" action="$scripturl?action=removethread" method="post" style="display: inline">
		<input type="hidden" name="thread" value="$viewnum" />
		</form>~;

	}
	$formstart .= qq~<form name="multidel" action="$scripturl?board=$currentboard;action=multidel;thread=$viewnum/$start" method="post" style="display: inline">~;
	$formend = qq~</form>~;

	$display_template =~ s/<yabb multistart>/$formstart/g;
	$display_template =~ s/<yabb multiend>/$formend/g;

	$display_template =~ s/<yabb pollmain>/$template_pollmain/g;
	$display_template =~ s/<yabb postsblock>/$tmpoutblock/g;
	$display_template =~ s/<yabb adminhandellist>/$adminhandellist/g;
	$display_template =~ s/<yabb forumselect>/$selecthtml/g;

	$yymain .= qq~
	$display_template
	<script language="JavaScript1.2" type="text/javascript">
	<!-- //

	function uncheckAllBut(counter) {
		//### Reverse Post Order ###
		var revers = "${$uid.$username}{'reverse_posts'}";
		if (revers == 'on'){
			var z = 0; 
			for (var i = $#msgtxt - $start; z < $maxmessagedisplay; i--) {
	 			if(i == counter) {document.multidel.elements[z].checked = true;}
				else {document.multidel.elements[z].checked = false;}
				z++;
			}
		}
		else {	
			for (var i = $start; i < $counter; i++) {
				var z = i - $start;
	 			if(i == counter) {document.multidel.elements[z].checked = true;}
				else {document.multidel.elements[z].checked = false;}
			}		
		}
		//### Reverse Post Order ###
		document.multidel.submit();
	}


	$pageindexjs
	// -->
	</script>
	~;
	&ToChars($msubthread);
### Quick Reply Box ###
#$scripturl?action=register;title=$display_txt{'116'}"
	# MBCO2 Reply access check
	if ($reply_users{$currentboard} || $reply_groups{$currentboard}) {
		my $access = &AccessCheck($currentboard, 2) || "";
		if ($access eq "denied") {$enable_quickreply = 0;}
	}
	if ($enable_guestposting == 0 && $iamguest){
	$enable_quickreply = 0;
	}

	if ($annboard eq $currentboard && !$iamadmin && !$iamgmod) {
	$enable_quickreply = 0;
	} elsif (&AccessCheck($currentboard, 2) ne "granted") {
	$enable_quickreply = 0;
	} elsif ($mstate =~ /l/) {
	$enable_quickreply = 0;
	}

	if ($enable_quickreply == 1) {
		$thestatus = $mstate;
		if ($thestatus =~ /s/) { $stselect = qq~<input type="hidden" name="topicstatus" value="s" />~; }
		if ($thestatus =~ /l/) { $lcselect = qq~<input type="hidden" name="topicstatus" value="l" />~; }
		if ($thestatus =~ /h/) { $hdselect = qq~<input type="hidden" name="topicstatus" value="h" />~; }

#	if ($username ne "Guest" && $mstate != 1 && $enable_quickreply == 1) {
$yymain .= qq~
<form action="$scripturl?board=$currentboard;action=post2" method="post" name="postmodify" enctype="multipart/form-data" onsubmit="if(!checkForm(this)) {return false} else {return submitproc()}">
$stselect
$lcselect
$hdselect
<input type="hidden" name="threadid" value="$viewnum" />
<input type="hidden" name="icon" value="xx" />
<table border=0 width="80%" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td align="center" class="titlebg" bgcolor="$color{'titlebg'}"><font size="2" class="text1" color="$color{'titletext'}"><b>$qrb_txt{'2'}</b></font></td>
  </tr>
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
      <table width="100%" cellpadding="4" cellspacing="0">
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$post_txt{'70'}:</b></font></td>
          <td><font size="2"><input type="text" name="subject" value="Re: $msubthread" size="40" style="width:100%" /></td>
        </tr>~;
        





		if ($enable_quicksmilies == 1) {
			if ($smiliestyle eq 1){$smiliewinlink = "$scripturl?action=smilieput";} else { $smiliewinlink = "$scripturl?action=smilieindex";}
			$moresmilieslist = ""; 
			$more_smilie_array = ""; 
			$i=0; 
			if ($showadded eq 1){ # show added smilies on smiley bar
				while($SmilieURL[$i]) { 
					if ($SmilieURL[$i]=~ /\//i) {$tmpurl = $SmilieURL[$i];} else {$tmpurl = qq~$defaultimagesdir/$SmilieURL[$i]~;}
					$moresmilieslist .= qq~      document.write("<img src='$tmpurl' align='bottom' alt='$SmilieDescription[$i]' border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand' />$SmilieLinebreak[$i] ");\n~; 
					$tmpcode = $SmilieCode[$i];
					$tmpcode =~ s/\&quot;/"+'"'+"/g;
					&FromHTML($tmpcode);
					$tmpcode =~ s/&#36;/\$/g;
					$tmpcode =~ s/&#64;/\@/g;
					$more_smilie_array .= qq~" $tmpcode", ~; 
					$i++; 
				} 
			}
			if ($showsmdir eq 1){ # show auto smilies on smiley bar
				opendir(DIR, "$smiliesdir"); 
				@contents = readdir(DIR); 
				closedir(DIR); 
				foreach $line (sort {uc($a) cmp uc($b)} @contents){ 
					($name, $extension) = split (/\./, $line); 
					if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i ){ 
						if ($line !~ /banner/i) { 
							$moresmilieslist .= qq~      document.write("<img src='$smiliesurl/$line' align='bottom' alt='$name' border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand' /> ");\n~; 
							$more_smilie_array .= qq~" [smiley=$line]", ~; 
							$i++ 
						} 
					} 
				} 
			}
			$more_smilie_array .= qq~""~; 
			}
			if ($enable_quickyabbc == 1) {
			$yymain .= qq~
			<tr><td valign="top" width="23%">&nbsp;</td>
			<td><table><tr><td>
			<script language="JavaScript1.2" type="text/javascript">
          HAND = "style='cursor: pointer; cursor: hand;'";
          document.write("<img src='$defaultimagesdir/url.gif' onclick='hyperlink();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'257'}' title='$post_txt{'257'}' border='0' />");
          document.write("<img src='$defaultimagesdir/ftp.gif' onclick='ftp();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'434'}' title='$post_txt{'434'}' border='0' />");
          document.write("<img src='$defaultimagesdir/img.gif' onclick='image();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'435'}' title='$post_txt{'435'}' border='0' />");
          document.write("<img src='$defaultimagesdir/email2.gif' onclick='emai1();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'258'}' title='$post_txt{'258'}' border='0' />");
          document.write("<img src='$defaultimagesdir/flash.gif' onclick='flash();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'433'}' title='$post_txt{'433'}' border='0' />");
          document.write("<img src='$defaultimagesdir/table.gif' onclick='table();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'436'}' title='$post_txt{'436'}' border='0' />");
          document.write("<img src='$defaultimagesdir/tr.gif' onclick='trow();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'449'}' title='$post_txt{'449'}' border='0' />");
          document.write("<img src='$defaultimagesdir/td.gif' onclick='tcol();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'437'}' title='$post_txt{'437'}' border='0' />");
          document.write("<img src='$defaultimagesdir/hr.gif' onclick='hr();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'531'}' title='$post_txt{'531'}' border='0' />");
          document.write("<img src='$defaultimagesdir/tele.gif' onclick='teletype();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'440'}' title='$post_txt{'440'}' border='0' />");
          document.write("<img src='$defaultimagesdir/code.gif' onclick='showcode();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'259'}' title='$post_txt{'259'}' border='0' />");
          document.write("<img src='$defaultimagesdir/quote2.gif' onclick='quote();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'260'}' title='$post_txt{'260'}' border='0' />");
          document.write("<img src='$defaultimagesdir/edit.gif' onclick='edit();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'603'}' title='$post_txt{'603'}' border='0' />");
          document.write("<img src='$defaultimagesdir/sup.gif' onclick='superscript();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'447'}' title='$post_txt{'447'}' border='0' />");
          document.write("<img src='$defaultimagesdir/sub.gif' onclick='subscript();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'448'}' title='$post_txt{'448'}' border='0' />");
          document.write("<img src='$defaultimagesdir/move.gif' onclick='move();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'439'}' title='$post_txt{'439'}' border='0' /></b>");
          document.write("<img src='$defaultimagesdir/timestamp.gif' onclick='timestamp($date);' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'245'}' title='$post_txt{'245'}' border='0' />");
          document.write("<img src='$modimgurl/SimpleSpoiler/spoiler.gif' onclick='spoiler();' "+HAND+" align='top' width='23' height='22' alt='$simplespoilertxt{'8'}' title='$simplespoilertxt{'8'}' border='0' /><br />");
          document.write("<img src='$defaultimagesdir/bold.gif' onclick='bold();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'253'}' title='$post_txt{'253'}' border='0' />");
          document.write("<img src='$defaultimagesdir/italicize.gif' onclick='italicize();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'254'}' title='$post_txt{'254'}' border='0' />");
          document.write("<img src='$defaultimagesdir/underline.gif' onclick='underline();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'255'}' title='$post_txt{'255'}' border='0' />");
          document.write("<img src='$defaultimagesdir/strike.gif' onclick='strike();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'441'}' title='$post_txt{'441'}' border='0' />");
          document.write("<img src='$defaultimagesdir/highlight.gif' onclick='highlight();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'246'}' title='$post_txt{'246'}' border='0' /></b>");
          document.write('<select name="fontface" id="fontface" onchange="if(this.options[this.selectedIndex].value) fontfce(this.options[this.selectedIndex].value);" style="width: 93px; margin-top: 2px; margin-left: 2px; margin-right: 1px; font-size: 9px;">');
          document.write('<option value="">Verdana</option>');
          document.write('<option value="">\\-\\-\\-\\-\\-</option>');
          document.write('<option value="Sans-Serif" style="font-family: Sans-Serif">Sans-Serif</option>');
          document.write('<option value="Verdana" style="font-family: Verdana" selected="selected">Verdana</option>');
          document.write('<option value="Arial" style="font-family: Arial">Arial</option>');
          document.write('<option value="Serif" style="font-family: Serif">Serif</option>');
          document.write('<option value="Courier" style="font-family: Courier">Courier</option>');
          document.write('<option value="Courier New" style="font-family: Courier New">Courier New</option>');
          document.write('<option value="Fantasy" style="font-family: Fantasy">Fantasy</option>');
          document.write('<option value="monospace" style="font-family: monospace">Monospace</option>');
          document.write('</select>');
          document.write('<select name="fontsize" id="fontsize" onchange="if(this.options[this.selectedIndex].value) fntsize(this.options[this.selectedIndex].value);" style="width: 39px; margin-top: 2px; margin-left: 1px; margin-right: 2px; font-size: 9px;">');
          document.write('<option value="">11</option>');
          document.write('<option value="">\\-\\-</option>');
          document.write('<option value="6">6</option>');
          document.write('<option value="7">7</option>');
          document.write('<option value="8">8</option>');
          document.write('<option value="9">9</option>');
          document.write('<option value="10">10</option>');
          document.write('<option value="11" selected="selected">11</option>');
          document.write('<option value="12">12</option>');
          document.write('<option value="14">14</option>');
          document.write('<option value="16">16</option>');
          document.write('<option value="18">18</option>');
          document.write('<option value="20">20</option>');
          document.write('<option value="22">22</option>');
          document.write('<option value="24">24</option>');
          document.write('<option value="36">36</option>');
          document.write('<option value="48">48</option>');
          document.write('<option value="56">56</option>');
          document.write('<option value="72">72</option>');
          document.write('</select>');
          document.write("<img src='$defaultimagesdir/pre.gif' onclick='pre();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'444'}' title='$post_txt{'444'}' border='0' />");
          document.write("<img src='$defaultimagesdir/left.gif' onclick='left();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'445'}' title='$post_txt{'445'}' border='0' />");
          document.write("<img src='$defaultimagesdir/center.gif' onclick='center();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'256'}' title='$post_txt{'256'}' border='0' />");
          document.write("<img src='$defaultimagesdir/right.gif' onclick='right();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'446'}' title='$post_txt{'446'}' border='0' />");
          document.write("<img src='$defaultimagesdir/list.gif' onclick='list();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'261'}' title='$post_txt{'261'}' border='0' />");
          document.write("<img src='$defaultimagesdir/me.gif' onclick='me();' "+HAND+" align=top width=23 height=22 alt='$post_txt{'604'}' title='$post_txt{'604'}' border='0' />");
          document.write("<img src='$modimgurl/SimpleSpoiler/spoiler-midtext.gif' onclick='spoiler2();' "+HAND+" align='top' width='23' height='22' alt='$simplespoilertxt{'9'}' title='$simplespoilertxt{'9'}' border='0' />");
          document.write("</td><td>");

          		img1 = new Image();
          		img1.src = "$defaultimagesdir/palette.gif";
             	         </script>
             	         
        <div style="height: 42px; width: 86px; overflow: auto; border: 1px; border-style: outset; float: right;">
        ~;
        for($z=0; $z<256; $z+=51) {
          $c3 = sprintf ("%02x", $z);
          for($y=0; $y<256; $y+=51) {
            $c2 = sprintf ("%02x", $y);
            for($x=0; $x<256; $x+=51) {
              $c1 = sprintf ("%02x", $x);
              $selcolor = qq~#$c1$c2$c3~;
if($ENV{'HTTP_USER_AGENT'} =~ /Safari/) {$yymain .= qq~<span style="background-color: $selcolor; width: 11px; height: 11px;"><img src="$defaultimagesdir/palette.gif" border="0" hspace="0" vspace="0" alt="" style="height: 11px; width: 11px; margin: 0px;" onclick="showcolor('$selcolor')" /></span>~;}
else {$yymain .= qq~<span style="float: left; background-color: $selcolor; width: 9px; height: 9px; border: 1px outset; font-size: 5px;" onclick="showcolor('$selcolor')">&nbsp;</span>~;}
            }
if($ENV{'HTTP_USER_AGENT'} =~ /Safari/) {$yymain .= qq~<br />~;}
          }
        }
        $yymain .= qq~
        </div>
        </td></tr></table>
        
          </td>
        </tr>
        ~;
    	}
	if ($enable_quicksmilies == 1) {
        $yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$post_txt{'297'}:</b></font></td>
          <td valign="middle">
          <script language="JavaScript1.2" type="text/javascript">
          <!--
            moresmiliecode = new Array($more_smilie_array) 

            function MoreSmilies(i) { 
              AddTxt=moresmiliecode[i]; 
              AddText(AddTxt); 
            }

            function smiliewin() {
              window.open("$smiliewinlink", 'list', 'width=$winwidth,height=$winheight, scrollbars=yes');
            }
  	  HAND = "style='cursor: pointer; cursor: hand;'";  
            if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {
          document.write("<img src='$defaultimagesdir/smiley.gif' onclick='smiley();' "+HAND+" align=bottom alt='$post_txt{'287'}' title='$post_txt{'287'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/wink.gif' onclick='wink();' "+HAND+" align=bottom alt='$post_txt{'292'}' title='$post_txt{'292'}' border='0 /'> ");
          document.write("<img src='$defaultimagesdir/cheesy.gif' onclick='cheesy();' "+HAND+" align=bottom alt='$post_txt{'289'}' title='$post_txt{'289'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/grin.gif' onclick='grin();' "+HAND+" align=bottom alt='$post_txt{'293'}' title='$post_txt{'293'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/angry.gif' onclick='angry();' "+HAND+" align=bottom alt='$post_txt{'288'}' title='$post_txt{'288'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/sad.gif' onclick='sad();' "+HAND+" align=bottom alt='$post_txt{'291'}' title='$post_txt{'291'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/shocked.gif' onclick='shocked();' "+HAND+" align=bottom alt='$post_txt{'294'}' title='$post_txt{'294'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/cool.gif' onclick='cool();' "+HAND+" align=bottom alt='$post_txt{'295'}' title='$post_txt{'295'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/huh.gif' onclick='huh();' "+HAND+" align=bottom alt='$post_txt{'296'}' title='$post_txt{'296'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/rolleyes.gif' onclick='rolleyes();' "+HAND+" align=bottom alt='$post_txt{'450'}' title='$post_txt{'450'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/tongue.gif' onclick='tongue();' "+HAND+" align=bottom alt='$post_txt{'451'}' title='$post_txt{'451'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/embarassed.gif' onclick='embarassed();' "+HAND+" align=bottom alt='$post_txt{'526'}' title='$post_txt{'526'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/lipsrsealed.gif' onclick='lipsrsealed();' "+HAND+" align=bottom alt='$post_txt{'527'}' title='$post_txt{'527'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/undecided.gif' onclick='undecided();' "+HAND+" align=bottom alt='$post_txt{'528'}' title='$post_txt{'528'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/kiss.gif' onclick='kiss();' "+HAND+" align=bottom alt='$post_txt{'529'}' title='$post_txt{'529'}' border='0' /> ");
          document.write("<img src='$defaultimagesdir/cry.gif' onclick='cry();' "+HAND+" align=bottom alt='$post_txt{'530'}' title='$post_txt{'530'}' border='0' /> ");
	  $moresmilieslist
      	    }

            else { document.write("<font size='1'>$txt{'215'}</font>"); }
          //-->
          </script>~;
		if ($showadded == 3 || ($showadded == 2 && $detachblock == 1) || $showsmdir == 3 || ($showsmdir == 2 && $detachblock == 1)){
			$yymain .= qq~
          <a href=javascript:smiliewin()>$smiltxt{'1'}</a>~;
		}
		$yymain .= qq~ 
          <noscript>
            <font size="1">$post_txt{'215'}</font>
          </noscript>
          </td>
        </tr>~;
		}
		$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$post_txt{'72'}:</b></font></td>
          <td><textarea name="message" rows="5" cols="60" wrap="soft" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" style="width:100%"></textarea></td>
        </tr>
~;
	# File Attachment's Browse Box Code
	if (&AccessCheck($currentboard, 4) eq "granted") {
		if ($enable_quickattach == 1 && $allowattach == 1 && ${$uid.$currentboard}{'attperms'} == 1 && $fa_ok == 1 && (($allowguestattach == 0 && !$iamguest) || $allowguestattach == 1)) {
			$yymain .= qq~
	<tr>
		<td width="23%" valign="top"><b>$qrb_txt{'11'}</b></td>
		<td width="77%"><input type="file" name="file" size="50"$selnewatt /></td>
	</tr>
	<tr>~;
		}
	}
	# /File Attachment's Browse Box Code

	$yymain .= qq~
      </table>
    </td>
  </tr>
  <tr>
    <td align="center" class="catbg" bgcolor="$color{'catbg'}"><input type="submit" name="post" value="$post_txt{'105'}" accesskey="s" /> &nbsp; <input type="submit" name="preview" value="$post_txt{'507'}" accesskey="p" tabindex="6" /> &nbsp; <input type="reset" name="clear" value="$post_txt{'278'}" accesskey="r" /></td>
  </tr>
</table>
</form>
~;
	}

### Quick Reply Box ###


	$yytitle = $msubthread;
	&template;
	exit;
}

sub NextPrev {
	fopen(MSGTXT, "$boardsdir/$currentboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt", 1);
	@threadlist = <MSGTXT>;
	fclose(MSGTXT);

	$thevirboard = qq~num=~;
	if ($vircurrentboard) {
		fopen(MSGTXT, "$boardsdir/$vircurrentboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $vircurrentboard.txt", 1);
		@virthreadlist = <MSGTXT>;
		fclose(MSGTXT);
		@threadlist = (@threadlist, @virthreadlist);
		$thevirboard = qq~virboard=$vircurrentboard;num=~;
	}

	$threadcount = $#threadlist;

	$countsticky   = 0;
	$countnosticky = 0;

	for ($i = 0; $i <= $threadcount; $i++) {
		my @array = split(/\|/, $threadlist[$i]);
		my $threadstatus = pop(@array);    #get only status
		undef @array;
		if ($threadstatus =~ /s/i || $threadstatus =~ /a/i) {
			$stickythreadlist[$countsticky] = $threadlist[$i];
			$countsticky++;
		} else {
			$nostickythreadlist[$countnosticky] = $threadlist[$i];
			$countnosticky++;
		}
	}

	if ($countsticky > 0) { @threadlist = (@stickythreadlist, @nostickythreadlist); }
	my $name = $_[0];
	$is = 0;
	for ($i = 0; $i <= $threadcount; $i++) {
		($mnum) = split(/\|/, $threadlist[$i]);
		if ($mnum == $name) {
			if ($i > 0) {
				($prev) = split(/\|/, $threadlist[$i - 1]);
				$prevlink = qq~<a href="$scripturl?$thevirboard$prev">$display_txt{'768'}</a>~;
			} else {
				$prevlink = qq~$display_txt{'766'}~;
			}
			if ($i < $threadcount) {
				($next) = split(/\|/, $threadlist[$i + 1]);
				$nextlink = qq~<a href="$scripturl?$thevirboard$next">$display_txt{'767'}</a>~;
			} else {
				$nextlink = qq~$display_txt{'766'}~;
			}
			$is = 1;
			last;
		}
	}
	if (!$is) { $yySetLocation = qq~$scripturl?~; &redirectexit; }    # boardlist if topic not found
}

sub SetMsn {

	$msnstyle = qq~<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />~;
	$msnstyle =~ s~$usestyle\/~~g;
	my $msnname = $INFO{'msnname'};
	if (!${$uid.$msnname}{'password'}) { &LoadUser($msnname); }
	$msnuser = ${$uid.$msnname}{'msn'};

	print qq~Content-type: text/html\n\n~;
	print qq~<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$msntxt{'5'}</title>
$msnstyle
</head>
<body class="windowbg2" style="margin: 0px; padding: 0px;">
<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
  <tr>
     <td class="titlebg" align="left" width="100%" height="22">
     <img src="$defaultimagesdir/msn3.gif" width="16" height="14" alt="" title="" border="0" />
     $msntxt{'5'}
     </td>
  </tr>
  <tr>
    <td align="center" valign="bottom" class="windowbg" width="100%" height="58">
	<img src="$defaultimagesdir/msn3.gif" width="16" height="16" style="vertical-align: middle;" alt="${$uid.$msnname}{'realname'}" title="${$uid.$msnname}{'realname'}" border='0' /> $msnuser<br /><br />

<script language="JavaScript1.2" type="text/javascript">
<!--

function sendmsn(msnto) {
	var msnControl = new ActiveXObject('Messenger.UIAutomation.1');
	if(!msnControl.MyContacts.Count) {
		alert("$msntxt{'3'}");
		return false;
	}
	msnControl.AutoSignin();
	msnControl.InstantMessage(msnto);
	window.close();
}

function addtomsn(msnto) {
	var msnControl = new ActiveXObject('Messenger.UIAutomation.1');
	msnControl.AutoSignin(); 
	msnControl.AddContact(0, msnto);
	window.close();
}

function notOnline() {
	alert("$msntxt{'3'}");
	return true;
}

if(navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4 && navigator.userAgent.indexOf("Opera") < 0) {
	var msnControl = new ActiveXObject('Messenger.UIAutomation.1');
	document.write("<input type='button' value='$msntxt{'1'}' style='font-size: 10px' onclick=sendmsn('$msnuser') />");
	document.write("<input type='button' value='$msntxt{'2'}' style='font-size: 10px' onclick=addtomsn('$msnuser') />");
}
else {
      document.write("$msntxt{'4'}<br /><br />");
}

window.onerror = notOnline;
//-->
</script>
    </td>
  </tr>
</table>
</body>
</html>
~;

}

sub SetGtalk {
	$gtalkstyle = qq~<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />~;
	$gtalkstyle =~ s~$usestyle\/~~g;
	my $gtalkname = $INFO{'gtalkname'};
	if (!${$uid.$gtalkname}{'password'}) { &LoadUser($gtalkname); }
	$gtalkuser = ${$uid.$gtalkname}{'gtalk'};

	print qq~Content-type: text/html\n\n~;
	print qq~<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>Google Talk</title>
$gtalkstyle
</head>
<body class="windowbg2" style="margin: 0px; padding: 0px;">
<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
  <tr>
     <td class="titlebg" align="left" width="100%" height="22">
     <img src="$defaultimagesdir/gtalk2.gif" width="16" height="14" alt="" title="" border="0" />
     Google Talk
     </td>
  </tr>
  <tr>
    <td align="center" valign="bottom" class="windowbg" width="100%" height="58">
	<img src="$defaultimagesdir/gtalk2.gif" width="16" height="14" style="vertical-align: middle;" alt="${$uid.$gtalkname}{'realname'}" title="${$uid.$gtalkname}{'realname'}" border='0' /> $gtalkuser<br /><br />
    </td>
  </tr>
</table>
</body>
</html>
~;

}

sub ThreadPageindex {
	my ($msindx, $trindx, $mbindx);
	($msindx, $trindx, $mbindx) = split(/\|/, ${$uid.$username}{'pageindex'});
	if ($INFO{'action'} eq "threadpagedrop") {
		${$uid.$username}{'pageindex'} = qq~$msindx|0|$mbindx~;
	}
	if ($INFO{'action'} eq "threadpagetext") {
		${$uid.$username}{'pageindex'} = qq~$msindx|1|$mbindx~;
	}
	&UserAccount($username, "update");
	$yySetLocation = qq~$scripturl?num=$INFO{'num'}/$INFO{'start'}~;
	&redirectexit;
}

sub undumplog {
	# Used to mark a thread as unread

	$thread = $INFO{'thread'};
	if ($iamguest || $max_log_days_old == 0) { return; }

	fopen(UNDUMPLOG, "+<$memberdir/$username.log");
	@entries = <UNDUMPLOG>;
	$edited  = 0;
	$i       = 0;
	foreach $entry (@entries) {
		if ($entry =~ m/\A$thread/) { $entries[$i] = "$thread--unread||$date\n"; $edited = 1; last; }
		$i++;
	}

	if ($edited) {
		seek UNDUMPLOG, 0, 0;
		truncate UNDUMPLOG, 0;
		print UNDUMPLOG @entries;
	}
	fclose(UNDUMPLOG);

	$yySetLocation = qq~$scripturl?board=$currentboard~;
	&redirectexit;
}

1;
